module Knowbe4Hiring
  # this class creates a job
  class Job
    attr_reader :id, :title, :language, :location, :mission_statement,
                :desired_abilities, :responsibilities, :requirements,
                :additional_qualifications

    def initialize(options)
      @id = options[:id]
      @title = options[:title]
      @language = options[:language]
      @location = options[:location]
      @mission_statement = options[:mission_statement]
      @desired_abilities = options[:desired_abilities]
      @responsibilities = options[:responsibilities]
      @requirements = options[:requirements]
      @additional_qualifications = options[:additional_qualifications]
    end

    def apply(name)
      `#{OS.open_file_command} #{mail_to_link(name)}`
    end

    private

    def mail_to_link(name)
      "mailto:\"hirethebest@knowbe4.com?subject=#{subject}&body=#{body(name)}\""
    end

    def subject
      "Application from Rails Conf, Job Opening: #{title}"
    end

    def full_position
      "#{language} #{title} position"
    end

    def body(name)
      body = "Hello KnowBe4 Hiring Team,\n"
      body += "My name is #{name} and I am interested in the #{full_position}."
      body += 'I would like to be considered for this role because I meet the '
      body += "following requirements: #{requirements}."
      body += "I welcome the opportunity to discuss this position further.\n\n"
      body += "Regards,\n#{name}"
      body
    end
  end
end
